/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pkg3dtestapplication;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.HashMap;
import java.util.Map;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.Group;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.TouchEvent;
import javafx.scene.layout.GridPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;

/**
 *
 * @author henri
 */
public class ColorChooseWidget extends Group {
    
    
    private Map<String, Color> colorMap = getJavaFXColorMap();
    private GridPane gridpane;
    int i = 0;
    private BoxModelObject b3d;
    
    public ColorChooseWidget(){
        
        gridpane = new GridPane();
        
        Image wireImg = new Image(getClass().getResourceAsStream("/resources/wireframe.png"));
        ImageView wire = new ImageView(wireImg);
        wire.setOnTouchPressed((TouchEvent event) ->{
                this.b3d.toggleWireframe();
            });
        gridpane.add(wire,i%20,(int)i/20);
        i++;
        // Sort the colors
        ObservableList<String> colors = FXCollections.observableArrayList(colorMap.keySet());
        FXCollections.sort(colors);
        
        for(String s : colors){
            Rectangle r = new Rectangle(50,50);
            r.setFill(colorMap.get(s));
            //System.out.println(s);
            r.setOnTouchPressed((TouchEvent event) ->{
                this.b3d.setColor(colorMap.get(s));
            });
            
            gridpane.add(r,i%20,(int)i/20);
            i++;
        }
        
        this.getChildren().add(gridpane);
    
    }
    
    public void setB3D(BoxModelObject b3d){
        this.b3d = b3d;
    }
    
    /**
 * Return a Map with all all defined colors in JavaFX. The key is the static
 * name of color and the value contains an instance of a Color object.
 */
public Map<String, Color> getJavaFXColorMap() {
    Field[] declaredFields = Color.class.getDeclaredFields();
    Map<String, Color> colors = new HashMap<>();
    for (Field field : declaredFields) {
        if (Modifier.isStatic(field.getModifiers()) && Modifier.isPublic(field.getModifiers())) {
            try {
                colors.put(field.getName(), (Color)field.get(null));
            } catch (SecurityException | IllegalArgumentException | IllegalAccessException ex) {
                
            }
        }
    }
    return colors;
}
    
}
