/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pkg3dtestapplication;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import javafx.animation.Interpolator;
import javafx.animation.KeyFrame;
import javafx.animation.KeyValue;
import javafx.animation.Timeline;
import javafx.geometry.Bounds;
import javafx.geometry.Point2D;
import javafx.geometry.Point3D;
import javafx.scene.Group;
import javafx.scene.SubScene;
import javafx.scene.input.MouseEvent;
import javafx.scene.input.ScrollEvent;
import javafx.scene.input.SwipeEvent;
import javafx.scene.input.TouchEvent;
import javafx.scene.input.TouchPoint;
import javafx.scene.input.ZoomEvent;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.CullFace;
import javafx.scene.shape.Cylinder;
import javafx.scene.shape.DrawMode;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.Rectangle;
import javafx.scene.shape.Sphere;
import javafx.scene.shape.TriangleMesh;
import javafx.scene.transform.Rotate;
import javafx.scene.transform.Translate;
import javafx.util.Duration;

/**
 *
 * @author henri
 */
public class ExtrusionWidget extends Xform {

    private CameraView camView;
    private SubScene scene;
    private double angleX, angleY , extrusionAngleX, extrusionAngleY;
    
    private BoxModelObject b3d;
    private final float EPS = 0.000001f;
    private Point3D activePos, activeNormal, currentCamPos;
    private ArrayList<Point3D> selectedFaces, tempFaces, sideFaces, eastFaces, westFaces, northFaces, southFaces, frontFaces, backFaces, up,down,left,right,originalFaces;
    private HashSet<Integer> alreadyExtruded;
    private HashSet<Point2D> extrusionIndices;
    private final Group extrusionPad;
    private Rectangle extrusionRect, extrusionXConstrainer, extrusionYConstrainer;
    private TouchPoint extrusionTouch;
    private ArrayList<TouchPoint> touchpoints;
    
    private Point3D xDirection = new Point3D(0,0,0);
    private Point3D yDirection = new Point3D(0,0,0);

    private String state;
    private final static String START = "start";
    private final static String EXTRUDE = "extrude";
    private final static String EXTRUDED = "extruded";
    private final static String TRANSFORM = "transform";
    
    private double currentExtrusionDistance = 0.0;
    private double directionDetectionTime = 0.0;
    private double currentDeltaX, currentDeltaY;
    
    private static final int NO_CONSTRAINT = 0;
    private static final int X_CONSTRAINT = 1;
    private static final int Y_CONSTRAINT = 2;
    
    private int extrusionConstraint = ExtrusionWidget.NO_CONSTRAINT;
    private boolean extruded = false;
    
    private long selectionDrawFactor = 0;
    private boolean selectionDrawMode = false;
    private long selectionDrawTime = 0;
    
    private double touchX, touchY = 0;
    
    private double extrusionAngleYDelta = 0;
    private double lastAngleYDelta = 0;
    private double extrusionAngleXDelta = 0;
    private double lastAngleXDelta = 0;
    private Point3D camPos, camPosY, camPosX;
    
    private int extrusionDirection = 0;
    private static final int UP = 1;
    private static final int DOWN = 2;
    private static final int LEFT = 3;
    private static final int RIGHT = 4;
    private static final int NONE = 0;
    
    private boolean isNav = false;

    private ExtrusionWidget(Builder builder) {

        this.state = ExtrusionWidget.START;
        this.scene = builder.scene;
        this.angleX = -10;
        
        camView = new CameraView(builder.scene);
        camView.setFitWidth(800);
        camView.setFitHeight(500);
        camView.startViewing();

        activePos = new Point3D(0, 0, -3);
        activeNormal = new Point3D(0, 0, -1);
        currentCamPos = new Point3D(0, 0, -20);

        this.touchpoints = new ArrayList<>();
        this.selectedFaces = new ArrayList<>();
        this.originalFaces = new ArrayList<>();
        this.tempFaces = new ArrayList<>();
        
        this.sideFaces = new ArrayList<>();
        this.eastFaces = new ArrayList<>();
        this.westFaces = new ArrayList<>();
        this.northFaces = new ArrayList<>();
        this.southFaces = new ArrayList<>();
        this.frontFaces = new ArrayList<>();
        this.backFaces = new ArrayList<>();
        this.up = new ArrayList<>();
        this.down = new ArrayList<>();
        this.left = new ArrayList<>();
        this.right = new ArrayList<>();
        this.alreadyExtruded = new HashSet<>();
        this.extrusionIndices = new HashSet<>();
        this.extrusionRect = new Rectangle(500, 500);

        extrusionXConstrainer = new Rectangle(450,50);
        extrusionXConstrainer.setFill(Color.CADETBLUE);
        
        extrusionYConstrainer = new Rectangle(50,450);
        extrusionYConstrainer.setTranslateX(450);
        extrusionYConstrainer.setTranslateY(50);
        extrusionYConstrainer.setFill(Color.CADETBLUE);
        
        this.extrusionPad = new Group();
        this.extrusionPad.setTranslateX(900);
        this.extrusionPad.getChildren().addAll(extrusionRect, extrusionXConstrainer, extrusionYConstrainer);
        this.getChildren().add(this.extrusionPad);
 
        this.extrusionPad.setOnTouchPressed((TouchEvent event) -> {

            TouchPoint tp = event.getTouchPoint();
            if(touchpoints.size() == 0){
                this.state = ExtrusionWidget.EXTRUDE;
                this.extrusionTouch = tp;
                touchX = tp.getX();
                touchY = tp.getY();
                //extrude();
            }else{
            }
            this.touchpoints.add(tp);
            extrusionAngleY = angleY;
            extrusionAngleX = angleX;
            extrusionAngleYDelta = 0;
            extrusionAngleXDelta = 0;
            currentExtrusionDistance = 0.0;
            directionDetectionTime = System.currentTimeMillis();
            currentDeltaX = currentDeltaY = 0;
            alreadyExtruded.clear();
            extrusionIndices.clear();
            //originalFaces.clear();
            
            double xPos = event.getTouchPoint().getX();
            double yPos = event.getTouchPoint().getY();
            
            if(yPos <=50 && xPos <= 450){
                this.extrusionConstraint = ExtrusionWidget.X_CONSTRAINT;
            }else if(xPos >= 450 && yPos > 50){
                this.extrusionConstraint = ExtrusionWidget.Y_CONSTRAINT;
            }else{
                this.extrusionConstraint = ExtrusionWidget.NO_CONSTRAINT;
            }
            event.consume();
        });
        this.extrusionPad.setOnTouchReleased((TouchEvent event) -> {
            
            TouchPoint toRemove = null;
            for (TouchPoint tp : touchpoints) {
                if (tp.equals(extrusionTouch)) {
                    toRemove = tp;
                    this.state = ExtrusionWidget.EXTRUDED;
                    touchX = tp.getX();
                    touchY = tp.getY();
                }
            }
            touchpoints.remove(toRemove);
            if (extruded) {

                prepareFaces();
                extruded = false;
            }
            lastAngleYDelta = extrusionAngleYDelta;
            lastAngleXDelta = extrusionAngleXDelta;
            
            updateSceneCameraPos();
            event.consume();
          
        });

        this.extrusionPad.setOnTouchMoved((TouchEvent event) -> {
            //System.out.println("SelFaces Start Scroll: "+ selectedFaces.size());
            double timeDiff = System.currentTimeMillis() - directionDetectionTime;
            double deltaX = event.getTouchPoint().getX() - touchX;
            double deltaY = event.getTouchPoint().getY() - touchY;
            if(this.extrusionConstraint == ExtrusionWidget.X_CONSTRAINT){
                deltaY = 0;
            }
            if(this.extrusionConstraint == ExtrusionWidget.Y_CONSTRAINT){
                deltaX = 0;
            }
            if(timeDiff <= 100){
                currentDeltaX += deltaX;
                currentDeltaY += deltaY;
            }else{
                
                if(!extruded){
                    //System.out.println("Starting extrusion");
                    extruded = true;
                    determineSelectedFaces(currentDeltaX,currentDeltaY);
                    
                    extrude();

                }
                if(extruded){
                    
                    
                    transformExtrudedFaces(deltaX, deltaY);
                    if(isNav){
                        if(currentExtrusionDistance > 0.5){
                            double angleDeltaY = angleY - extrusionAngleY;
                            double angleDeltaX = angleX - extrusionAngleX;
                            
                            
                            extrusionAngleY = angleY;
                            extrusionAngleX = angleX;
                            if(Math.abs(angleDeltaX) < 5){
                                angleDeltaX = 0;
                                extrusionAngleYDelta += angleDeltaY;
                            }
                                
                            if(Math.abs(angleDeltaY) < 5){
                                angleDeltaY = 0;
                                extrusionAngleXDelta += angleDeltaX;
                            }
                                
                            rotateFaces(selectedFaces,angleDeltaY,angleDeltaX);
                            //rotateFaces(selectedFaces,angleDeltaX);
                            extrude();
                            currentExtrusionDistance = 0;
                            //System.out.println("AngleXDelta: "+extrusionAngleXDelta);
                        }
                    }
                }    
                    
            }
            touchX = event.getTouchPoint().getX();
            touchY = event.getTouchPoint().getY();
            event.consume();
        });

        this.extrusionPad.addEventFilter(ZoomEvent.ANY, (final ZoomEvent zoomEvent) -> {
            zoomEvent.consume();
        });
        this.extrusionPad.addEventFilter(ScrollEvent.ANY, (final ScrollEvent scrollEvent) -> {
            scrollEvent.consume();
        });
        this.extrusionPad.addEventFilter(MouseEvent.ANY, (final MouseEvent mouseEvent) -> {
            mouseEvent.consume();
        });

        this.getChildren().add(camView);
        this.addEventFilter(MouseEvent.ANY, (final MouseEvent mouseEvent) -> {
            mouseEvent.consume();
        });

//        camView.setOnTouchPressed((TouchEvent event) -> {
//            selectFace(activeNormal, activePos, event);
//            event.consume();
//        });
        camView.setOnTouchPressed((TouchEvent event) -> {
            selectionDrawFactor = 0;
            selectionDrawMode = false;
            selectionDrawTime = System.currentTimeMillis();
            selectFace(activeNormal, activePos, event);
            event.consume();
        });
        
        camView.setOnTouchMoved((TouchEvent event) -> {
            
            if((System.currentTimeMillis() - selectionDrawTime) > 50){
                selectionDrawMode = true;
            }
            
            if(selectionDrawMode){
                selectFace(activeNormal, activePos, event);
            }
                
            selectionDrawFactor ++;
            
            event.consume();
        });
        
        camView.setOnTouchReleased((TouchEvent event) -> {
            selectionDrawFactor = 0;
            selectionDrawMode = false;
            event.consume();
        });

        camView.setOnZoom((ZoomEvent event) -> {

            double factor = event.getZoomFactor();
            factor = mapValue(factor, 0, 2, -1, 1);
            camView.getCamera().setTranslateZ((camView.getCamera().getTranslateZ()) + (factor * 5));
            event.consume();
        });
        
        camView.setOnSwipeUp((SwipeEvent event) -> {
            initExtrusion();
            event.consume();
        });

    }
    
    private void lookAtAnimated(Point3D origin, Point3D target){

        camView.getCamera().setTranslateX(0);
        camView.getCamera().setTranslateY(0);
        camView.getCamera().setTranslateZ(0);
        
        camView.getCameraTransform().setTranslateX(0);
        camView.getCameraTransform().setTranslateY(0);
        camView.getCameraTransform().setTranslateZ(0);

        Point3D zAxis = target.subtract(origin);
        zAxis = zAxis.normalize();
        //System.out.println("Z-Angle: "+ Math.toDegrees(Math.acos(zAxis.dotProduct(new Point3D(0,0,1)))));
        
        Point3D up = new Point3D(0,1,0);
        Point3D xAxis = up.crossProduct(zAxis);
        xAxis = xAxis.normalize(); 
        //System.out.println("X-Angle: "+ Math.toDegrees(Math.acos(xAxis.dotProduct(new Point3D(1,0,0)))));
        
        Point3D yAxis = zAxis.crossProduct(xAxis);
        yAxis = yAxis.normalize();
        //System.out.println("Y-Angle: "+ Math.toDegrees(Math.acos(yAxis.dotProduct(new Point3D(0,1,0)))));
        
        
        double alpha = Math.toDegrees(Math.acos(yAxis.dotProduct(new Point3D(0,1,0))));
        double gamma = Math.toDegrees(Math.acos(zAxis.dotProduct(new Point3D(0,0,1))));
        
        
        Point3D normalCross = zAxis.crossProduct(new Point3D(0,0,1));
        double normalCrossAngleX = new Point3D(0,1,0).dotProduct(normalCross); 
        
        Point3D normalCross2 = yAxis.crossProduct(new Point3D(0,1,0));
        double normalCrossAngleY = xAxis.dotProduct(normalCross2);

        
        if(normalCrossAngleX < 0){
            gamma = -gamma;
        }
        
        if(normalCrossAngleY < 0){
            alpha = -alpha;
        }
        
        if(xAxis.magnitude() == 0 || yAxis.magnitude() == 0){
            gamma = 0;
            alpha = Math.toDegrees(Math.asin(zAxis.getY()));
        }
        
        final Timeline timeline = new Timeline();
        final KeyValue kv = new KeyValue(camView.getCameraTransform().ry.angleProperty(), -gamma, Interpolator.EASE_BOTH);
        final KeyValue kv2 = new KeyValue(camView.getCameraTransform().rx.angleProperty(), -alpha, Interpolator.EASE_BOTH);
        final KeyValue kv3 = new KeyValue(camView.getCameraTransform().translateXProperty(), origin.getX(), Interpolator.EASE_BOTH);
        final KeyValue kv4 = new KeyValue(camView.getCameraTransform().translateYProperty(), origin.getY(), Interpolator.EASE_BOTH);
        final KeyValue kv5 = new KeyValue(camView.getCameraTransform().translateZProperty(), origin.getZ(), Interpolator.EASE_BOTH);
        final KeyFrame kf = new KeyFrame(Duration.millis(3000), kv);
        final KeyFrame kf2 = new KeyFrame(Duration.millis(3000), kv2);
        final KeyFrame kf3 = new KeyFrame(Duration.millis(3000), kv3);
        final KeyFrame kf4 = new KeyFrame(Duration.millis(3000), kv4);
        final KeyFrame kf5 = new KeyFrame(Duration.millis(3000), kv5);
        timeline.getKeyFrames().addAll(kf, kf2, kf3, kf4, kf5);
        timeline.play();
    }
    
    private void lookAt(Point3D origin, Point3D target){

//        System.out.println("Origin: "+origin);
//        System.out.println("Target: "+target);
        
        camView.getCamera().setTranslateX(0);
        camView.getCamera().setTranslateY(0);
        camView.getCamera().setTranslateZ(0);
        
        camView.getCameraTransform().setTranslateX(0);
        camView.getCameraTransform().setTranslateY(0);
        camView.getCameraTransform().setTranslateZ(0);
   
        Point3D zAxis = target.subtract(origin);
        zAxis = zAxis.normalize();
        
        Point3D up = new Point3D(0,1,0);
        Point3D xAxis = up.crossProduct(zAxis);
        xAxis = xAxis.normalize(); 
        
        Point3D yAxis = zAxis.crossProduct(xAxis);
        yAxis = yAxis.normalize();

        double alpha = Math.toDegrees(Math.acos(yAxis.dotProduct(new Point3D(0,1,0))));
        double gamma = Math.toDegrees(Math.acos(zAxis.dotProduct(new Point3D(0,0,1))));

        Point3D normalCross = zAxis.crossProduct(new Point3D(0,0,1));
        double normalCrossAngleX = new Point3D(0,1,0).dotProduct(normalCross); 
        
        Point3D normalCross2 = yAxis.crossProduct(new Point3D(0,1,0));
        double normalCrossAngleY = xAxis.dotProduct(normalCross2);

        
        if(normalCrossAngleX < 0){
            gamma = -gamma;
        }
        
        if(normalCrossAngleY < 0){
            alpha = -alpha;
        }
        
        if(xAxis.magnitude() == 0 || yAxis.magnitude() == 0){
            gamma = 0;
            alpha = Math.toDegrees(Math.asin(zAxis.getY()));
        }
        
        camView.getCameraTransform().ry.setAngle(-gamma);
        camView.getCameraTransform().rx.setAngle(-alpha);
        camView.getCameraTransform().setTranslateX(origin.getX());
        camView.getCameraTransform().setTranslateY(origin.getY());
        camView.getCameraTransform().setTranslateZ(origin.getZ());

    }
    
    public void setNav(boolean nav){
        isNav = nav;
    }
    public void setCamPos(Point3D pos){
        this.camPosX = pos;
        this.camPosY = pos;
        this.camPos = pos;
    }
    private void rotateFaces(ArrayList<Point3D> faces, double angleY, double angleX) {
        HashSet<Integer> points = new HashSet<>();
        for (Point3D face : faces) {
            points.add((int) face.getX());
            points.add((int) face.getY());
            points.add((int) face.getZ());
        }

        for (Integer i : points) {
            Point3D b = getPointFromMesh(i);
            Point3D origin = getMidpointOfFaces(faces);
            origin = new Point3D(origin.getX() / 3.0, origin.getY() / 3.0, origin.getZ() / 3.0);
//            Sphere s = new Sphere(0.4);
//            s.setTranslateX(origin.getX());
//            s.setTranslateY(origin.getY());
//            s.setTranslateZ(origin.getZ());
//            b3d.getChildren().add(s);

            b = b.add(-origin.getX(), -origin.getY(), -origin.getZ());
            Rotate roty = new Rotate(angleY, new Point3D(0, 1, 0));
            Rotate rotx = new Rotate(angleX, new Point3D(1, 0, 0));
            b = roty.transform(b);
            b = rotx.transform(b);
            //xDirection = roty.transform(xDirection);
            //xDirection = roty.transform(xDirection);
            b = b.add(origin);
            setPointInMesh(i, b);
        }

    }
    
    private Point3D getMidpointOfFaces(ArrayList<Point3D> faces){
        double minX;
        double minY;
        double minZ;
        double maxX;
        double maxY;
        double maxZ;

        if (faces.size() >0){
            ArrayList<Point3D> points = b3d.getFacePoints(faces.get(0));
            minX = points.get(0).getX();
            maxX = points.get(0).getX();
            
            minY = points.get(0).getY();
            maxY = points.get(0).getY();
            
            minZ = points.get(0).getZ();
            maxZ = points.get(0).getZ();
            
        }else{
        return new Point3D(0,0,0);
        }
        for(Point3D p : faces){
            for(Point3D o : b3d.getFacePoints(p)){
                double xx = o.getX();
                double yy = o.getY();
                double zz = o.getZ();
                
                if(xx < minX){
                    minX = xx;
                }else if(xx > maxX){
                    maxX = xx;
                }
                
                if(yy < minY){
                    minY = yy;
                }else if(yy > maxY){
                    maxY = yy;
                }
                
                if(zz < minZ){
                    minZ = zz;
                }else if(zz > maxZ){
                    maxZ = zz;
                }
            }
        }
        
        double x = (minX + maxX) / 2;
        double y = (minY + maxY) / 2;
        double z = (minZ + maxZ) / 2;
        //System.out.println("Midpoint: "+x+", "+y+", "+z);
        return new Point3D(x,y,z);
    }
    
    private void initExtrusion(){
            this.selectedFaces.clear();
            this.southFaces.clear();
            this.northFaces.clear();
            this.eastFaces.clear();
            this.westFaces.clear();
            this.frontFaces.clear();
            this.backFaces.clear();
            this.originalFaces.clear();
            this.up.clear();
            this.down.clear();
            this.left.clear();
            this.right.clear();
            this.tempFaces.clear();
            this.sideFaces.clear();
            b3d.getExtrusionWidgetContent().getChildren().clear();
    };

    private void determineSelectedFaces(double dX, double dY) {
        
        if(sideFaces.isEmpty()){
            if (Math.abs(dX) > Math.abs(dY)) {
                if (dX > 0) {
                    extrusionDirection = ExtrusionWidget.RIGHT;
                } else if (dX < 0) {
                    extrusionDirection = ExtrusionWidget.LEFT;
                }
            } else if (Math.abs(dX) < Math.abs(dY)) {
                if (dY < 0) {
                    extrusionDirection = ExtrusionWidget.UP;
                } else if (dY > 0) {
                    extrusionDirection = ExtrusionWidget.DOWN;
                }
            } else {
                extrusionDirection = ExtrusionWidget.NONE;
            }
            return;
        }
        ArrayList<Point3D> saveFaces = new ArrayList();
        saveFaces.addAll(selectedFaces);
        selectedFaces.clear();
        
//        System.out.println("Delta X: "+ dX);
//        System.out.println("Delta Y: "+ dY);
//        System.out.println("Right: "+ right.size());
//        System.out.println("Left: "+ left.size());
//        System.out.println("Up: "+ up.size());
//        System.out.println("Down: "+ down.size());
        
        if(Math.abs(dX) > Math.abs(dY)){
            if(dX > 0){
               selectedFaces.addAll(right);
               extrusionDirection = ExtrusionWidget.RIGHT;
            }else if(dX <0){
                selectedFaces.addAll(left);
                extrusionDirection = ExtrusionWidget.LEFT;
            }
        }else if(Math.abs(dX) < Math.abs(dY)){
            if(dY < 0){
               selectedFaces.addAll(up);
               extrusionDirection = ExtrusionWidget.UP;
            }else if(dY > 0){
                selectedFaces.addAll(down);
                extrusionDirection = ExtrusionWidget.DOWN;
            }
        }else{
            selectedFaces.addAll(selectedFaces);
            extrusionDirection = ExtrusionWidget.NONE;
        }
        
    }

    private double round(double value, int places) {
        if (places < 0) {
            throw new IllegalArgumentException();
        }

        BigDecimal bd = new BigDecimal(value);
        bd = bd.setScale(places, RoundingMode.HALF_UP);
        return bd.doubleValue();
    }

    private void prepareFaces() {
        eastFaces.clear();
        westFaces.clear();
        northFaces.clear();
        southFaces.clear();
        frontFaces.clear();
        backFaces.clear();

        boolean isSelectedFaceInteractive = false;
        
        if(sideFaces.size() > 0 && selectedFaces.size() > 0){
            
            left.clear();
            right.clear();
            up.clear();
            down.clear();
            
            Point3D selectedFacesNormal = b3d.getFaceNormal(selectedFaces.get(0));
            
            Point3D upV = new Point3D(0, 1, 0);
            
            Point3D zAxis = selectedFacesNormal;
            zAxis = zAxis.normalize();

            Point3D xAxis = upV.crossProduct(zAxis);
            xAxis = xAxis.normalize();

            Point3D yAxis = zAxis.crossProduct(xAxis);
            yAxis = yAxis.normalize();

            
            Rotate camRotY = new Rotate(angleY,0,0,0,new Point3D(0,1,0));
            Rotate camRotX = new Rotate(angleX,0,0,0,new Point3D(1,0,0));

            camPos = new Point3D(0,0,-50);
            camPos = camRotX.transform(camPos);
            camPos = camRotY.transform(camPos);

            Point3D camZ = new Point3D(camPos.getX(),camPos.getY(),camPos.getZ());

            camZ = camZ.normalize();
            
            Point3D camX = upV.crossProduct(camZ);
            camX = camX.normalize();
            
            Point3D camY = camZ.crossProduct(camX);
            camY = camY.normalize();
            
//            showAxis(camPos,camPos.add(camX.multiply(20)),Color.RED);
//            showAxis(camPos,camPos.add(camY.multiply(20)),Color.GREEN);
//            showAxis(camPos,camPos.add(camZ.multiply(20)),Color.BLUE);

            double angleXX = Math.toDegrees(Math.acos(camX.dotProduct(zAxis)));
            double angleYY = Math.toDegrees(Math.acos(camY.dotProduct(zAxis)));
            double angleZZ = Math.toDegrees(Math.acos(camZ.dotProduct(zAxis)));

            for(Point3D sf: selectedFaces){
                if (angleXX > 315 || angleXX < 45.0) {
                    if(Math.abs(angleX)>90.0 && Math.abs(angleX)<270){
                        right.add(sf);
                    }else{
                        left.add(sf);
                    }
                    isSelectedFaceInteractive = true;
                }

                if (angleXX > 135.0 && angleXX < 225.0) {
                    if(Math.abs(angleX)>90.0 && Math.abs(angleX)<270){
                        left.add(sf);
                    }else{
                        right.add(sf);
                    }
                    isSelectedFaceInteractive = true;
                }

                if (angleYY > 135.0 && angleYY <= 180.0) {
                    
                    if(Math.abs(angleX)>90.0 && Math.abs(angleX)<270){
                        down.add(sf);
                    }else{
                        up.add(sf);
                    }
                    isSelectedFaceInteractive = true;
                }

                if (angleYY >= 0 && angleYY < 45) {
                    
                    if(Math.abs(angleX)>90.0 && Math.abs(angleX)<270){
                        up.add(sf);
                    }else{
                        down.add(sf);
                    }
                    isSelectedFaceInteractive = true;
                }
            }
            
            
       
            
            
            for(Point3D p : sideFaces){
                Point3D normal = b3d.getFaceNormal(p);
                normal = normal.normalize();
                ArrayList<Point3D> pp = new ArrayList();
                pp.add(p);
                Point3D midPoint = getMidpointOfFaces(pp);
                Point3D normal2 = midPoint.add(normal.multiply(5));
                
                angleXX = Math.toDegrees(Math.acos(camX.dotProduct(normal)));
                angleYY = Math.toDegrees(Math.acos(camY.dotProduct(normal)));
                angleZZ = Math.toDegrees(Math.acos(camZ.dotProduct(normal)));
                
                //System.out.println("CamPos: "+camPos);
                if(angleXX >315 || angleXX <45.0){
                    if(Math.abs(angleX)>90.0 && Math.abs(angleX)<270){
                        right.add(p);
                    }else{
                        left.add(p);
                    }
                }

                if (angleXX > 135.0 && angleXX < 225.0) {
                    if(Math.abs(angleX)>90.0 && Math.abs(angleX)<270){
                        left.add(p);
                    }else{
                        right.add(p);
                    };
                }

                if (angleYY > 135.0 && angleYY <= 180.0) {
                    if(Math.abs(angleX)>90.0 && Math.abs(angleX)<270){
                        down.add(p);
                    }else{
                        up.add(p);
                    }
                }

                if (angleYY >= 0 && angleYY < 45) {
                    if(Math.abs(angleX)>90.0 && Math.abs(angleX)<270){
                        up.add(p);
                    }else{
                        down.add(p);
                    }
                }

            }
            b3d.getExtrusionWidgetContent().getChildren().clear();
            for (Point3D f : right) {
                mapFace(f, Color.BURLYWOOD);
            }

            for (Point3D f : left) {
                mapFace(f, Color.BEIGE);
            }

            for (Point3D f : up) {
                mapFace(f, Color.GREENYELLOW);
            }

            for (Point3D f : down) {
                mapFace(f, Color.GREEN);
            }

            if (isSelectedFaceInteractive == true) {
                for (Point3D f : selectedFaces) {
                    mapFace(f, Color.AQUAMARINE);
                }
            }
        }
        
        
    }
    
    private void showAxis(Point3D origin, Point3D target, Color color){
        Point3D dir = target.subtract(origin).crossProduct(new Point3D(0, -1, 0));
        double angle = Math.acos(target.subtract(origin).normalize().dotProduct(new Point3D(0, -1, 0)));
        double h1 = target.subtract(origin).magnitude();
        Cylinder c = new Cylinder(0.05d, h1);
        c.getTransforms().addAll(new Translate(origin.getX(), origin.getY() - h1 / 2d, origin.getZ()),
                new Rotate(-Math.toDegrees(angle), 0d, h1 / 2d, 0d,
                        new Point3D(dir.getX(), -dir.getY(), dir.getZ())));
        c.setMaterial(new PhongMaterial(color));
        b3d.getChildren().add(c);
    }
    
    private void showSphere(double radius, Point3D location){
        Sphere s = new Sphere(radius);
        s.setTranslateX(location.getX());
        s.setTranslateY(location.getY());
        s.setTranslateZ(location.getZ());
        b3d.getChildren().add(s);
    }
    
    private void transformExtrudedFaces(double deltaX, double deltaY) {
        
        
        if(selectedFaces.isEmpty()){
            return;
        }
        

        Point3D normal = b3d.getFaceNormal(selectedFaces.get(0));
        normal = normal.normalize();

        double dX = deltaX / 50;
        double dY = deltaY / 50;
        
        if(extrusionDirection == ExtrusionWidget.LEFT)
            dX = -dX;
        if(extrusionDirection == ExtrusionWidget.UP)
            dY = -dY;

        Point3D newP2 = new Point3D(normal.getX(),normal.getY(),normal.getZ());
        if(dX != 0.0)// && dY == 0)
            newP2 = newP2.multiply(dX);
        if(dY != 0.0)// && dX == 0)
            newP2 = newP2.multiply(dY);
        if(dX == 0.0 && dY == 0.0){
            newP2 = newP2.multiply(0.0);
        }
        if(dX != 0 && dY != 0){
            if(extrusionDirection == ExtrusionWidget.LEFT || extrusionDirection == ExtrusionWidget.RIGHT){
                newP2 = newP2.multiply(dX);
                newP2 = newP2.add(new Point3D(0,1,0).multiply(dY));
            }
            if(extrusionDirection == ExtrusionWidget.UP || extrusionDirection == ExtrusionWidget.DOWN){
                newP2 = newP2.multiply(dY);
                newP2 = newP2.add(new Point3D(0,1,0).multiply(dX));
            }
        }
        Point3D ep = new Point3D(0,0,0);
        Point3D op = new Point3D(0,0,0);
        if (this.state.equals(ExtrusionWidget.EXTRUDED) || this.state.equals(ExtrusionWidget.EXTRUDE)) {

            HashSet<Integer> points = new HashSet<>();
            for (Point3D face : selectedFaces) {
                points.add((int) face.getX());
                points.add((int) face.getY());
                points.add((int) face.getZ());
            }

            for (Integer i : points) {
                Point3D a = getPointFromMesh(i);
                op = a;
                a = a.add(newP2);
                
                
                ep = a;
                setPointInMesh(i, a);
                
                
            }
            

        }
        double delta = op.subtract(ep).magnitude();
        currentExtrusionDistance += delta;


    }
    
    public void setSceneCameraAngles(double x, double y){
        this.angleX = x % 360;
        this.angleY = y % 360;
        prepareFaces();
    }
    
    private List<Point2D> findDoubleEdges(ArrayList<Point3D> faces){
    
       List<Point2D> edges = new ArrayList<>();
       HashSet<Integer> toDelete = new HashSet<>();
       for(Point3D f : faces){
        double a = f.getX();
        double b = f.getY();
        double c = f.getZ();

        edges.add(new Point2D(a,b));
        edges.add(new Point2D(a,c));
        edges.add(new Point2D(b,c));
       }
    
       for(int i = 0; i < edges.size(); i++){
           for(int j = 1; j < edges.size(); j++){
               if(i!=j){
               Point2D e1 = edges.get(i);
               Point2D e2 = edges.get(j);
               
               if((e1.getX() == e2.getX() && e1.getY() == e2.getY()) || (e1.getX() == e2.getY() && e1.getY() == e2.getX())){

                   toDelete.add(i);
                   toDelete.add(j);
               }
               }
               
           }
     
       }
       
       ArrayList<Point2D> deleteList = new ArrayList<>();
       for(Integer i : toDelete){
           deleteList.add(edges.get(i));
       }
       //edges.removeAll(deleteList);
       

       
       return deleteList;
    }
    
    private void extrude(){
        
        if (selectedFaces.size() > 0) {
            sideFaces.clear();
            originalFaces.clear();
            originalFaces.addAll(selectedFaces);
            List<Point2D> doubleEdges = findDoubleEdges(selectedFaces);
            
            for (Point3D face : selectedFaces) {
                ArrayList<Point3D> faces = extrudeFace(face,doubleEdges);
                
                for(Point3D nf : faces){
                    if(faces.indexOf(nf) == 0){
                        tempFaces.add(nf);
                    }else{
                        sideFaces.add(nf);
                    }
                }
            } 

            this.b3d.getExtrusionWidgetContent().getChildren().clear();
            selectedFaces.clear();
            selectedFaces.addAll(tempFaces);
            tempFaces.clear();   
        }
                 
    }
    
    private void repairNormals(ArrayList<Point3D> extrudedFaces){
    
        Point3D centroid = getCentroid(extrudedFaces);
        
        showSphere(0.5, centroid);
        
        for(Point3D f : extrudedFaces){
            Point3D faceC = getCenterOfFace(f);
            Point3D normal = b3d.getFaceNormal(f);
            
            Point3D invertedNormal = new Point3D(-normal.getX(), -normal.getY(), -normal.getZ());
            
            System.out.println("normal: "+normal);
            System.out.println("inormal: "+invertedNormal);
            
            Point3D a = faceC.add(normal);
            Point3D b = faceC.add(invertedNormal);
            showSphere(0.2, a);
            double aa = a.subtract(centroid).magnitude();
            double bb = b.subtract(centroid).magnitude();
            System.out.println("aa: "+aa);
            System.out.println("bb "+bb);
            if(bb > aa){
                System.out.println("Repair normals");
            }
        }
        
    }
    
    private Point3D getCenterOfFace(Point3D f){
        double x = 0;
        double y = 0;
        double z = 0;
        
        Point3D a = getPointFromMesh((int)f.getX());
        Point3D b = getPointFromMesh((int)f.getY());
        Point3D c = getPointFromMesh((int)f.getZ());
        
        x += a.getX()*3;
        y += a.getY()*3;
        z += a.getZ()*3;

        x += b.getX()*3;
        y += b.getY()*3;
        z += b.getZ()*3;

        x += c.getX()*3;
        y += c.getY()*3;
        z += c.getZ()*3;
        
        x /= 3;
        y /= 3;
        z /= 3;
        
        return new Point3D(x,y,z);
        
    }
    
    private Point3D getCentroid(ArrayList<Point3D> extrudedFaces){
        double x = 0;
        double y = 0;
        double z = 0;
        for(Point3D f : extrudedFaces){
            Point3D a = getPointFromMesh((int)f.getX());
            Point3D b = getPointFromMesh((int)f.getY());
            Point3D c = getPointFromMesh((int)f.getZ());
            
            x += a.getX();
            y += a.getY();
            z += a.getZ();
            
            x += b.getX();
            y += b.getY();
            z += b.getZ();
            
            x += c.getX();
            y += c.getY();
            z += c.getZ();
        }
        
        x /= extrudedFaces.size();
        y /= extrudedFaces.size();
        z /= extrudedFaces.size();
        
        return new Point3D(x,y,z);
    }


    private void selectFace(Point3D normal, Point3D pos, TouchEvent event) {

        double x = event.getTouchPoint().getX();
        double y = event.getTouchPoint().getY();

        Point3D camPos = new Point3D(camView.getTranslateX(),camView.getTranslateY(),camView.getTranslateZ());

        camPos = camView.getCamera().localToScene(camPos);
        camPos = b3d.sceneToLocal(camPos);
        
        currentCamPos = camPos;

        Point3D fromCam = pos.subtract(camPos);
        double aspectRatio = 8.0 / 5.0;

        double distance = Math.abs(fromCam.magnitude());

        double ya = (Math.tan(Math.toRadians(15.0)) * distance) / aspectRatio * 1.6;

        double xa = (Math.tan(Math.toRadians(15.0)) * distance) * 1.6;

        double v = mapValue(y, 0, 500, -ya, ya);

        double u = mapValue(x, 0, 800, -xa, xa);

        Point3D origin = camPos;
  
        Point3D target = new Point3D(u, v, distance);
        target = camView.getCamera().localToScene(target);
        target = b3d.sceneToLocal(target);

        castRay(origin, target);
    }
    
    public void updateSceneCameraPos(){

        if(!selectedFaces.isEmpty()){
            Point3D midPoint = getMidpointOfFaces(selectedFaces);
            Point3D faceNormal = b3d.getFaceNormal(selectedFaces.get(0));
            faceNormal = faceNormal.normalize();
            Point3D midPoint2 = midPoint.add(faceNormal.multiply(20));
            
            lookAtAnimated(midPoint2,midPoint);
        }    
  
       
    }

    public void setCamView(Point3D pos, Point3D normal) {
        
        initExtrusion();

        normal = normal.normalize();
        //For Flipped Normals//normal = new Point3D(-normal.getX(),-normal.getY(),-normal.getZ());
        activePos = pos;
        activeNormal = normal;
        
        Point3D cam = pos.add(normal.multiply(20));
        lookAtAnimated(cam,pos);


    }

    private int getExtrusionPointIndex(int index){
        int result = -1;
        for(Point2D pp : extrusionIndices){
            if(pp.getX() == index){
                result = (int)pp.getY();
            }
        }
        return result;
    }
    
    private ArrayList<Point3D> extrudeFace(Point3D face, List<Point2D> doubleEdges) {
 
        ArrayList<Point3D> extrudedFaces = new ArrayList<>();
        //First, retrieve indices to points array of mesh 
        int indexOld1 = (int) face.getX();
        int indexOld2 = (int) face.getY();
        int indexOld3 = (int) face.getZ();
        
        boolean io1 = false;
        boolean io2 = false;
        boolean io3 = false;

        
        if(!alreadyExtruded.contains(indexOld1)){
            alreadyExtruded.add(indexOld1);
        }else{
            io1 = true;
        }
        if(!alreadyExtruded.contains(indexOld2)){
            alreadyExtruded.add(indexOld2);
        }else{
            io2 = true;
        }
        if(!alreadyExtruded.contains(indexOld3)){
            alreadyExtruded.add(indexOld3);
        }else{
            io3 = true;
        }
        
        boolean iab = true;
        boolean iac = true;
        boolean ibc = true;
        
        int index1 = -1;
        int index2 = -1;
        int index3 = -1;
        
        Point2D ab = new Point2D(face.getX(),face.getY());
        Point2D ac = new Point2D(face.getX(),face.getZ());
        Point2D bc = new Point2D(face.getY(),face.getZ());

        //get the index of the face in the face array, in order to update it later with the extruded face
        int indexOfOldFace = b3d.getFaceIndex(face);

        if(!io1){
            Point3D p = new Point3D(round(b3d.getMesh().getPoints().get(indexOld1 * 3),3), round(b3d.getMesh().getPoints().get(indexOld1 * 3 + 1),3), round(b3d.getMesh().getPoints().get(indexOld1 * 3 + 2),3));
            float[] pp = {(float) p.getX(), (float) p.getY(), (float) p.getZ()};
            b3d.getMesh().getPoints().addAll(pp);
            index1 = (b3d.getMesh().getPoints().size()) / 3 - 1;
            extrusionIndices.add(new Point2D(indexOld1,index1));
        }else{
            index1 = getExtrusionPointIndex(indexOld1);
        }
           
        if(!io2){
            Point3D p = new Point3D(round(b3d.getMesh().getPoints().get(indexOld2 * 3),3), round(b3d.getMesh().getPoints().get(indexOld2 * 3 + 1),3), round(b3d.getMesh().getPoints().get(indexOld2 * 3 + 2),3));
            float[] pp = {(float) p.getX(), (float) p.getY(), (float) p.getZ()};
            b3d.getMesh().getPoints().addAll(pp);
            index2 = (b3d.getMesh().getPoints().size()) / 3 - 1;
            extrusionIndices.add(new Point2D(indexOld2,index2));
        }
        else{
            index2 = getExtrusionPointIndex(indexOld2);
        }
        if(!io3){
            Point3D p = new Point3D(round(b3d.getMesh().getPoints().get(indexOld3 * 3),3), round(b3d.getMesh().getPoints().get(indexOld3 * 3 + 1),3), round(b3d.getMesh().getPoints().get(indexOld3 * 3 + 2),3));
            float[] pp = {(float) p.getX(), (float) p.getY(), (float) p.getZ()};
            b3d.getMesh().getPoints().addAll(pp);
            index3 = (b3d.getMesh().getPoints().size()) / 3 - 1;
            extrusionIndices.add(new Point2D(indexOld3,index3));
        }
        else{
            index3 = getExtrusionPointIndex(indexOld3);
        }
        
        for(Point2D de : doubleEdges){
            if(((ab.getX() == de.getX() && ab.getY() == de.getY()) || (ab.getX() == de.getY() && ab.getY() == de.getX())) && iab){
                iab = false;
                //System.out.println("remove ab: "+ab);
            }
            if(((ac.getX() == de.getX() && ac.getY() == de.getY()) || (ac.getX() == de.getY() && ac.getY() == de.getX())) && iac){
                iac = false;
                //System.out.println("remove ac: "+ac);
            }
            if(((bc.getX() == de.getX() && bc.getY() == de.getY()) || (bc.getX() == de.getY() && bc.getY() == de.getX())) && ibc){
                ibc = false;
                //System.out.println("remove bc: "+bc);
            }
        }

        //Define the new faces with the old and new points
        int[] ff = {index1, 0, index2, 0, index3, 0};
        b3d.getMesh().getFaces().set(indexOfOldFace * 6, ff, 0, 6);
        
        int numFSmooth = 0;
        if(iac){
            int[] ac1 = {index3, 0, indexOld1, 0, index1, 0};
            int[] ac2 = {index3, 0, indexOld3, 0, indexOld1, 0};
            b3d.getMesh().getFaces().addAll(ac1);
            b3d.getMesh().getFaces().addAll(ac2);
            numFSmooth += 2;
        }

        if(ibc){
            int[] ba1 = {index3, 0, index2, 0, indexOld3, 0};
            int[] ba2 = {indexOld3, 0, index2, 0, indexOld2, 0};
            b3d.getMesh().getFaces().addAll(ba1);
            b3d.getMesh().getFaces().addAll(ba2);
            numFSmooth += 2;
        }
        
        if(iab){
            int[] cb1 = {index2, 0, index1, 0, indexOld1, 0};
            int[] cb2 = {index2, 0, indexOld1, 0, indexOld2, 0};
            b3d.getMesh().getFaces().addAll(cb1);
            b3d.getMesh().getFaces().addAll(cb2);
            numFSmooth += 2;
        }
        int[] smooths = new int[numFSmooth];
        for(int i = 0; i< numFSmooth; i++){
            smooths[i] = 0;
        }
        
        //EastSide
        Point3D a = new Point3D(index3,indexOld1,index1);
        Point3D b = new Point3D(index3,indexOld3,indexOld1);
        
        //SouthSide
        Point3D c = new Point3D(index3,index2,indexOld3);
        Point3D d = new Point3D(indexOld3,index2,indexOld2);
        
        //WestSide
        Point3D e = new Point3D(index2,index1,indexOld1);
        Point3D f = new Point3D(index2,indexOld1,indexOld2);
        
        //update the mesh smoothing groups
        b3d.getMesh().getFaceSmoothingGroups().addAll(smooths);

        Point3D newTopFace = new Point3D(index1, index2, index3);
        extrudedFaces.add(newTopFace);
        
        if(iac){
            extrudedFaces.add(a);
            extrudedFaces.add(b);
        }
        
        if(ibc){
            extrudedFaces.add(c);
            extrudedFaces.add(d);
        }
        
        if(iab){
            extrudedFaces.add(e);
            extrudedFaces.add(f);
        }
        

        return extrudedFaces;
    }

    private double mapValue(double value, double oldLow, double oldHigh, double newLow, double newHigh) {
        return (value - oldLow) / (oldHigh - oldLow) * (newHigh - newLow) + newLow;
    }

    private void castRay(Point3D origin, Point3D target) {
        Point3D gloOrigin = origin;
        Point3D gloTarget = target;
        Point3D gloDirection = gloTarget.subtract(gloOrigin).normalize();

        Bounds locBounds = b3d.getBoundsInLocal();
        List<Point3D> normals = Arrays.asList(new Point3D(-1, 0, 0), new Point3D(1, 0, 0),
                new Point3D(0, -1, 0), new Point3D(0, 1, 0), new Point3D(0, 0, -1), new Point3D(0, 0, 1));
        List<Point3D> positions = Arrays.asList(new Point3D(locBounds.getMinX(), 0, 0),
                new Point3D(locBounds.getMaxX(), 0, 0), new Point3D(0, locBounds.getMinY(), 0),
                new Point3D(0, locBounds.getMaxY(), 0), new Point3D(0, 0, locBounds.getMinZ()),
                new Point3D(0, 0, locBounds.getMaxZ()));

        Point3D dir = gloTarget.subtract(gloOrigin).crossProduct(new Point3D(0, -1, 0));
        double angle = Math.acos(gloTarget.subtract(gloOrigin).normalize().dotProduct(new Point3D(0, -1, 0)));
        double h1 = gloTarget.subtract(gloOrigin).magnitude();
//        Cylinder c = new Cylinder(0.05d, h1);
//        c.getTransforms().addAll(new Translate(gloOrigin.getX(), gloOrigin.getY() - h1 / 2d, gloOrigin.getZ()),
//                new Rotate(-Math.toDegrees(angle), 0d, h1 / 2d, 0d,
//                        new Point3D(dir.getX(), -dir.getY(), dir.getZ())));
//        b3d.getChildren().add(c);
        Point3D gloOriginInLoc = b3d.sceneToLocal(gloOrigin);

        AtomicInteger counter = new AtomicInteger();

        IntStream.range(0, 6).forEach(i -> {
            double d = -normals.get(i).dotProduct(positions.get(i));
            double t = -(gloOriginInLoc.dotProduct(normals.get(i)) + d)
                    / (gloDirection.dotProduct(normals.get(i)));

            Point3D locInter = gloOriginInLoc.add(gloDirection.multiply(t));
            if (locBounds.contains(locInter)) {
                counter.getAndIncrement();
            }
        });

        List<Point3D> faces = getIntersections(gloOrigin, gloDirection, b3d.getVertices(false), b3d.getFaces(false));

        if (faces.size() > 0) {
            Point3D face = faces.get(0);
            for (Point3D f : faces) {

                if (getDistanceToFace(currentCamPos, f) < (getDistanceToFace(currentCamPos, face))) {
                    face = f;
                }
            }

            if (faceAlreadySelected(face)) {
                if(!selectionDrawMode)
                    this.selectedFaces.remove(face);
            } else {
                this.selectedFaces.add(face);
            }

            b3d.getExtrusionWidgetContent().getChildren().clear();

            //draw selected Faces
            for (Point3D f : selectedFaces) {
                mapFace(f, Color.AQUAMARINE);
                //System.out.println("selected face normal: "+b3d.getFaceNormal(f));
            }
        }

    }

    private double getDistanceToFace(Point3D origin, Point3D face) {
        Point3D a = b3d.getVertices(false).get((int) face.getX());
        Point3D b = b3d.getVertices(false).get((int) face.getZ());
        Point3D c = b3d.getVertices(false).get((int) face.getY());
        Point3D s = ((a.add(b).add(c))).multiply(1 / 3d);

        double distance = s.subtract(origin).magnitude();
        return distance;
    }

    private boolean faceAlreadySelected(Point3D face) {
        boolean result = false;
        for (Point3D f : this.selectedFaces) {
            if (f.getX() == face.getX() && f.getY() == face.getY() && f.getZ() == face.getZ()) {
                result = true;
            }
        }
        return result;
    }

    private List<Point3D> getIntersections(Point3D origin, Point3D direction,
            List<Point3D> points, List<Point3D> faces) {

        return faces.parallelStream().filter(f -> {
            // vertices indices
            int p0 = (int) f.getX();
            int p1 = (int) f.getY();
            int p2 = (int) f.getZ();

            // vertices 3D coordinates
            Point3D a = points.get(p0);
            Point3D b = points.get(p1);
            Point3D c = points.get(p2);

            Point3D edge1 = b.subtract(a);
            Point3D edge2 = c.subtract(a);
            Point3D pvec = direction.crossProduct(edge2);
            double det = edge1.dotProduct(pvec);

            if (det <= -EPS || det >= EPS) {
                double inv_det = 1f / det;
                Point3D tvec = origin.subtract(a);
                double u = tvec.dotProduct(pvec) * inv_det;
                if (u >= 0f && u <= 1f) {
                    Point3D qvec = tvec.crossProduct(edge1);
                    double v = direction.dotProduct(qvec) * inv_det;
                    if (v >= 0 && u + v <= 1f) {
                        double t = c.dotProduct(qvec) * inv_det;
                        //System.out.println("t: " + t + ", u: " + u + ", v: " + v);
                        return true;
                    }
                }
            }
            return false;
        }).collect(Collectors.toList());
    }

    private Point3D getPointFromMesh(int index) {
        Point3D p = new Point3D(b3d.getMesh().getPoints().get(index * 3), b3d.getMesh().getPoints().get(index * 3 + 1), b3d.getMesh().getPoints().get(index * 3 + 2));
        return p;
    }

    private void setPointInMesh(int index, Point3D point) {

        b3d.getMesh().getPoints().set(index * 3, (float) point.getX());
        b3d.getMesh().getPoints().set(index * 3 + 1, (float) point.getY());
        b3d.getMesh().getPoints().set(index * 3 + 2, (float) point.getZ());

    }

    private void mapFace(Point3D face, Color color) {

        int index1 = (int) face.getX();
        int index2 = (int) face.getY();
        int index3 = (int) face.getZ();

        ArrayList<Point3D> verts = b3d.getVertices(true);
        TriangleMesh mesh = new TriangleMesh();
        Point3D a = verts.get(index1);
        Point3D b = verts.get(index3);
        Point3D c = verts.get(index2);

        float points[] = {
            (float) a.getX(), (float) a.getY(), (float) a.getZ(),
            (float) b.getX(), (float) b.getY(), (float) b.getZ(),
            (float) c.getX(), (float) c.getY(), (float) c.getZ()
        };
        mesh.getPoints().addAll(points);
        int faces[] = {0, 0, 2, 0, 1, 0};
        mesh.getFaces().addAll(faces);
        float tex[] = {0.0f, 0.0f};
        mesh.getTexCoords().addAll(tex);

        MeshView meshView = new MeshView(mesh);
        meshView.setCullFace(CullFace.NONE);
        meshView.setDrawMode(DrawMode.FILL);
        meshView.setMaterial(new PhongMaterial(color));

        Group meshGroup = new Group(meshView);
        b3d.getExtrusionWidgetContent().getChildren().add(meshGroup);
    }

    public void setB3D(BoxModelObject b3d) {
        this.b3d = b3d;
        double x = this.b3d.t.getTx();
        double y = this.b3d.t.getTy();
        double z = this.b3d.t.getTz();
        
        camView.getCamera().setTranslateX(b3d.t.getTx());
        camView.getCamera().setTranslateY(b3d.t.getTy());
        camView.getCamera().setTranslateZ(b3d.t.getTz()-20);


    }

    public static class Builder {

        private SubScene scene;

        public Builder(SubScene scene) {
            this.scene = scene;
        }

        public ExtrusionWidget build() {
            return new ExtrusionWidget(this);
        }
    }

}
